	cpu LMM
	.module sensor.c
	.area lit(rom, con, rel)
_FactoryDefault_Param_8::
	.byte 0,0
	.dbfile ./sensor.c
	.dbsym e FactoryDefault_Param_8 _FactoryDefault_Param_8 A[2:2]c
_FactoryDefault_Param_16::
	.word 500
	.word 500
	.word 50000
	.dbsym e FactoryDefault_Param_16 _FactoryDefault_Param_16 A[6:3]i
_FactoryDefault_Param_32::
	.word 0,0
	.dbsym e FactoryDefault_Param_32 _FactoryDefault_Param_32 A[4:1]l
_FactoryDefault_Param_168::
	.byte 'I,'R,32,'M,'o,'t,'i,'o,'n,32,'D,'e,'t,'e,'c,'t
	.byte 'o,'r,0
	.byte 0,0
	.byte 'F,'r,'a,'m,'e,32,'N,'u,'m,'b,'e,'r,0
	.byte 0,0,0,0,0,0,0,0
	.byte 'M,'o,'t,'i,'o,'n,32,'C,'o,'u,'n,'t,0
	.byte 0,0,0,0,0,0,0,0
	.word 0,0,0,0,0
	.word 0,0,0,0,0
	.byte 0
	.dbsym e FactoryDefault_Param_168 _FactoryDefault_Param_168 A[84:4:21]c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_NewSample::
	.byte 0
	.dbsym e NewSample _NewSample c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
	.area text(rom, con, rel)
	.dbfile ./sensor.c
	.dbfunc e Sensor_Start _Sensor_Start fV
_Sensor_Start::
	.dbline -1
	.dbline 96
; //*****************************************************************************
; //*****************************************************************************
; //  FILENAME:   sensor.c
; //  Version: 1.0, 2007/03/08
; //  Generated by Andy Kiser
; //
; //  DESCRIPTION:  sensor specific functions 
; //
; //-----------------------------------------------------------------------------
; // Originally authored by Toradex AG. This work is now available under the terms and conditions
; // of the Creative Commons License 'Attribution CC BY', details of which can be found here:
; // http://creativecommons.org/licenses/by/3.0/
; //*****************************************************************************
; //*****************************************************************************
; //#define __DEBUG__
; #include <m8c.h>        // part specific constants and macros
; #include "sensor.h"
; #include "psocgpioint.h"
; #include "feature.h"
; #include "parameters.h"
; #include "types_n_macros.h"
; //----------------------------------------
; // Sensor parameters
; // Factory Defaults are defined here (NUM_xxx are defined in "sensor.h")
; //----------------------------------------
; const BYTE FactoryDefault_Param_8   [NUM_PARAM_8] =
; {
; 	0x00,		// report mode
; 	0x00		// LED mode
; };
; 
; const WORD FactoryDefault_Param_16  [NUM_PARAM_16] = 
; {
; 	500,		// report rate [ms]
; 	500,		// sample rate [ms]
; 	50000		// sample rate [us]	(not used for this sensor)
; };
; 
; const DWORD FactoryDefault_Param_32  [NUM_PARAM_32] =
; {
; 	0x00000000	// currently no 32bit parameters
; };
; 
; const tParam_168 FactoryDefault_Param_168 [NUM_PARAM_168] =
; {
; 	"IR Motion Detector",	// user device name
; 	"Frame Number",			// user name Channel 0
; 	"Motion Count"			// user name Channel 1
; };
; 
; 
; //----------------------------------------
; // this module's global variables
; //----------------------------------------
; tReport Report;
; 
; //----------------------------------------
; // constant lookup-table for conversion ADC->physical value
; //----------------------------------------
; 
; 
; //----------------------------------------
; // type definitions
; //----------------------------------------
; 
; typedef enum 
; {	
; 	eReset,
; 	eIdle,
; 	eReadCounter,
; 	eStartWait,
; } tFSM_Measure;
; 
; //----------------------------------------
; // variables
; 
; tFSM_Measure	FSM;
; WORD			Countdown_1ms;
; 
; BOOL			NewSample = FALSE;
; 
; // store original drivemodes during suspend
; BYTE			DM0_2, DM0_1, DM0_0;
; BYTE			DM2_2, DM2_1, DM2_0;
; 
; //----------------------------------------
; // function prototypes
; static void MS55XX_Reset(void);
; static void MS55XX_ReadCalibration(void);
; static BYTE MS55XX_TxRx (BYTE TxData, BYTE size);
; 
; //-----------------------------------------------------------------------------
; // Initializes the Sensor 
; //-----------------------------------------------------------------------------
; void Sensor_Start ()
; {
	.dbline 97
; 	FSM = eReset;
	mov REG[0xd0],>_FSM
	mov [_FSM],0
	.dbline 100
; 
; 	// necessary for proper Pulldown-configuration
; 	GPIO_LOW(MOTION)
	and REG[0x8],-17
	.dbline 106
; 
; 	// turn on power to the sensor
; 	//GPIO_HIGH(ON_nOFF)
; 	
; 	// initialize motion counter
; 	MotionCounter = 0;
	mov REG[0xd0],>_MotionCounter
	mov [_MotionCounter+1],0
	mov [_MotionCounter],0
	.dbline 109
; 
; 	// Enable GPIO interrupt for MOTION input
; 	MOTION_IntEn_ADDR |= MOTION_MASK;
	or REG[0x9],16
	.dbline 110
; 	INT_MSK0 |= INT_MSK0_GPIO;
	or REG[0xe0],32
	.dbline -2
	.dbline 111
; }
L8:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Sensor_Suspend _Sensor_Suspend fV
_Sensor_Suspend::
	.dbline -1
	.dbline 117
; 
; //-----------------------------------------------------------------------------
; // Prepare Sensor for Suspend
; //-----------------------------------------------------------------------------
; void Sensor_Suspend()
; {
	.dbline 119
; 	// store original drivemodes during  suspend
; 	DM0_2 = PRT0DM2;
	mov A,REG[0x3]
	mov REG[0xd0],>_DM0_2
	mov [_DM0_2],A
	.dbline 120
; 	DM0_1 = PRT0DM1;
	or F,0x10  ; iopage = 1
	mov A,REG[0x1]
	mov REG[0xd0],>_DM0_1
	mov [_DM0_1],A
	and F,0xEF ; iopage = 0
	.dbline 121
; 	DM0_0 = PRT0DM0;
	or F,0x10  ; iopage = 1
	mov A,REG[ 0]
	mov REG[0xd0],>_DM0_0
	mov [_DM0_0],A
	and F,0xEF ; iopage = 0
	.dbline 122
; 	DM2_2 = PRT2DM2;
	mov A,REG[0xb]
	mov REG[0xd0],>_DM2_2
	mov [_DM2_2],A
	.dbline 123
; 	DM2_1 = PRT2DM1;
	or F,0x10  ; iopage = 1
	mov A,REG[0x9]
	mov REG[0xd0],>_DM2_1
	mov [_DM2_1],A
	and F,0xEF ; iopage = 0
	.dbline 124
; 	DM2_0 = PRT2DM0;
	or F,0x10  ; iopage = 1
	mov A,REG[0x8]
	mov REG[0xd0],>_DM2_0
	mov [_DM2_0],A
	and F,0xEF ; iopage = 0
	.dbline 127
; 		
; 	// disable GPIO interrupt
; 	INT_MSK0 &= ~INT_MSK0_GPIO;
	and REG[0xe0],-33
	.dbline 130
; 	
; 	// turn off power for the sensor
; 	GPIO_LOW(ON_nOFF)
	and REG[0x8],-65
	.dbline 133
; 
; 	// set all I/Os to/from the sensor to High-Z Analog (=110), 
; 	PRT0DM2  = 0xFF;
	mov REG[0x3],-1
	.dbline 134
; 	PRT0DM1  = 0xFF;
	or F,0x10  ; iopage = 1
	mov REG[0x1],-1
	and F,0xEF ; iopage = 0
	.dbline 135
; 	PRT0DM0  = 0x00;
	or F,0x10  ; iopage = 1
	mov REG[ 0],0
	and F,0xEF ; iopage = 0
	.dbline 136
; 	PRT2DM2  = 0xFF;
	mov REG[0xb],-1
	.dbline 137
; 	PRT2DM1  = 0xFF;
	or F,0x10  ; iopage = 1
	mov REG[0x9],-1
	and F,0xEF ; iopage = 0
	.dbline 138
; 	PRT2DM0  = 0x00;
	or F,0x10  ; iopage = 1
	mov REG[0x8],0
	and F,0xEF ; iopage = 0
	.dbline -2
	.dbline 139
; }
L9:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Sensor_Resume _Sensor_Resume fV
_Sensor_Resume::
	.dbline -1
	.dbline 144
; //-----------------------------------------------------------------------------
; // Resume Sensor from Suspend mode
; //-----------------------------------------------------------------------------
; void Sensor_Resume()
; {
	.dbline 146
; 	// restore drivemodes for GPIOs to/from the sensor
; 	PRT2DM2 = DM2_2;
	mov REG[0xd0],>_DM2_2
	mov A,[_DM2_2]
	mov REG[0xb],A
	.dbline 147
; 	PRT2DM1 = DM2_1;
	or F,0x10  ; iopage = 1
	mov REG[0xd0],>_DM2_1
	mov A,[_DM2_1]
	mov REG[0x9],A
	and F,0xEF ; iopage = 0
	.dbline 148
; 	PRT2DM0 = DM2_0;
	or F,0x10  ; iopage = 1
	mov REG[0xd0],>_DM2_0
	mov A,[_DM2_0]
	mov REG[0x8],A
	and F,0xEF ; iopage = 0
	.dbline 150
; 
; 	PRT0DM2 = DM0_2;
	mov REG[0xd0],>_DM0_2
	mov A,[_DM0_2]
	mov REG[0x3],A
	.dbline 151
; 	PRT0DM1 = DM0_1;
	or F,0x10  ; iopage = 1
	mov REG[0xd0],>_DM0_1
	mov A,[_DM0_1]
	mov REG[0x1],A
	and F,0xEF ; iopage = 0
	.dbline 152
; 	PRT0DM0 = DM0_0;
	or F,0x10  ; iopage = 1
	mov REG[0xd0],>_DM0_0
	mov A,[_DM0_0]
	mov REG[ 0],A
	and F,0xEF ; iopage = 0
	.dbline 154
; 
; 	Sensor_Start();
	xcall _Sensor_Start
	.dbline -2
	.dbline 155
; }
L10:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc s amn1x11x_ReadCount _amn1x11x_ReadCount fi
;            cnt -> X+0
_amn1x11x_ReadCount:
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 161
; 
; //-----------------------------------------------------------------------------
; // Read ADC 
; //-----------------------------------------------------------------------------
; static WORD amn1x11x_ReadCount (void)
; {
	.dbline 164
; 	WORD cnt;
; 	
; 	M8C_DisableGInt;	// avoid updating of the counter during readout
		and F, FEh

	.dbline 165
; 	cnt = MotionCounter;
	mov REG[0xd0],>_MotionCounter
	mov A,[_MotionCounter+1]
	mov [X+1],A
	mov A,[_MotionCounter]
	mov [X+0],A
	.dbline 166
; 	MotionCounter = 0;
	mov [_MotionCounter+1],0
	mov [_MotionCounter],0
	.dbline 167
; 	M8C_EnableGInt;
		or  F, 01h

	.dbline 169
; 
; 	return cnt;
	mov REG[0xd0],>__r0
	mov A,[X+1]
	mov [__r1],A
	mov A,[X+0]
	mov [__r0],A
	.dbline -2
L11:
	add SP,-2
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l cnt 0 i
	.dbend
	.dbfunc e Sensor_Specific_Feature _Sensor_Specific_Feature fc
_Sensor_Specific_Feature::
	.dbline -1
	.dbline 183
; }
; 
; //-----------------------------------------------------------------------------
; // Function that will be called when a FEATURE REPORT is received that 
; // cannot be handled with the standard functionality in feature.c
; // The feature report data is available in the "FEATURE_RPT" variable
; //
; // --> see feature.c for an example how to parse FEATURE_RPT
; //
; //	return Value: number of Parameter bytes (1-31) that are 
; //				  returned in the IN report
; //-----------------------------------------------------------------------------
; BYTE Sensor_Specific_Feature(void)
; {
	.dbline 185
; 	// currently no special feature reports are handled
; 	return 0;
	mov REG[0xd0],>__r0
	mov A,0
	.dbline -2
L12:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Sensor_Specific_Parameter _Sensor_Specific_Parameter fV
; NumberOfReturnedBytes -> X-5
_Sensor_Specific_Parameter::
	.dbline -1
	push X
	mov X,SP
	.dbline 196
; }
; 
; //-----------------------------------------------------------------------------
; // Function that will be called when a FEATURE REPORT is received that 
; // sets / gets a 8/16/32/168bit parameter in feature.c
; // The feature report data is available in the "FEATURE_RPT" variable
; //
; // --> see feature.c for an example how to parse FEATURE_RPT
; //-----------------------------------------------------------------------------
; void Sensor_Specific_Parameter(BYTE *NumberOfReturnedBytes)
; {
	.dbline -2
	.dbline 198
; 	// Oak-Move does not have specific parameters
; }
L13:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l NumberOfReturnedBytes -5 pc
	.dbend
	.dbfunc e Sensor_FSM_Measure _Sensor_FSM_Measure fV
;     NofMotions -> X+2
_Sensor_FSM_Measure::
	.dbline -1
	push X
	mov X,SP
	add SP,4
	.dbline 210
; 
; //-----------------------------------------------------------------------------
; // void Sensor_FSM_Measure(void)
; //
; //	finite state machine to control the measurement process for 
; //  the sensor
; //
; //  IMPORTANT: 	call this routine once every millisecond. Otherwise the timing
; //				parameters cannot be met.
; //-----------------------------------------------------------------------------
; void Sensor_FSM_Measure() 
; {
	.dbline 212
; 	// decrement millisecond counter
; 	if (Countdown_1ms != 0)
	mov REG[0xd0],>_Countdown_1ms
	cmp [_Countdown_1ms],0
	jnz X1
	cmp [_Countdown_1ms+1],0
	jz L15
X1:
	.dbline 213
; 		Countdown_1ms--;
	mov REG[0xd0],>_Countdown_1ms
	dec [_Countdown_1ms+1]
	sbb [_Countdown_1ms],0
L15:
	.dbline 216
; 
; 	// process actual state machine
; 	switch (FSM)
	mov REG[0xd0],>_FSM
	mov A,[_FSM]
	mov [X+1],A
	mov [X+0],0
	cmp [X+0],0
	jnz X2
	cmp [X+1],0
	jz L20
X2:
	cmp [X+0],0
	jnz X3
	cmp [X+1],1
	jz L24
X3:
	cmp [X+0],0
	jnz X4
	cmp [X+1],2
	jz L27
X4:
	cmp [X+0],0
	jnz X5
	cmp [X+1],3
	jz L21
X5:
	xjmp L17
X0:
	.dbline 217
; 	{
L20:
	.dbline 219
; 		case eReset:
; 			Countdown_1ms = 1000; // 1s delay until USB is inizalized
	mov REG[0xd0],>_Countdown_1ms
	mov [_Countdown_1ms+1],-24
	mov [_Countdown_1ms],3
	.dbline 220
; 			FSM = eStartWait;
	mov REG[0xd0],>_FSM
	mov [_FSM],3
	.dbline 221
; 			break;
	xjmp L18
L21:
	.dbline 224
; 			
; 		case eStartWait:	//Waiting for initialization of USB for preventing power supply toggeling
; 			if (Countdown_1ms == 0)
	mov REG[0xd0],>_Countdown_1ms
	cmp [_Countdown_1ms],0
	jnz L18
	cmp [_Countdown_1ms+1],0
	jnz L18
X6:
	.dbline 225
; 			{
	.dbline 226
; 				GPIO_HIGH(ON_nOFF)
	or REG[0x8],64
	.dbline 227
; 				Countdown_1ms = 1; // 1ms delay until first measurement finished
	mov REG[0xd0],>_Countdown_1ms
	mov [_Countdown_1ms+1],1
	mov [_Countdown_1ms],0
	.dbline 228
; 				FSM = eIdle;
	mov REG[0xd0],>_FSM
	mov [_FSM],1
	.dbline 229
; 			}
	.dbline 230
; 			break;
	xjmp L18
L24:
	.dbline 233
; 			
; 		case eIdle: 
; 			if (Countdown_1ms == 0)
	mov REG[0xd0],>_Countdown_1ms
	cmp [_Countdown_1ms],0
	jnz L18
	cmp [_Countdown_1ms+1],0
	jnz L18
X7:
	.dbline 234
; 			{
	.dbline 235
; 	  		    Get_Param_16(PAR16_SAMPLERATE_MS, VOLATILE, &Countdown_1ms);
	mov A,>_Countdown_1ms
	push A
	mov A,<_Countdown_1ms
	push A
	mov A,0
	push A
	mov A,1
	push A
	xcall _Get_Param_16
	add SP,-4
	.dbline 236
; 				FSM = eReadCounter;
	mov REG[0xd0],>_FSM
	mov [_FSM],2
	.dbline 237
; 			}
	.dbline 238
; 			break;			
	xjmp L18
L27:
	.dbline 241
; 			
; 		case eReadCounter:
; 			{
	.dbline 243
; 				WORD NofMotions;
; 				NofMotions = amn1x11x_ReadCount();
	xcall _amn1x11x_ReadCount
	mov REG[0xd0],>__r0
	mov A,[__r1]
	mov [X+3],A
	mov A,[__r0]
	mov [X+2],A
	.dbline 246
; 			
; 				// fill measured data into IN REPORT
; 				Report.Ch1_LSB = NofMotions & 0xFF;
	mov A,[X+3]
	mov REG[0xd0],>_Report
	mov [_Report+2],A
	.dbline 247
; 				Report.Ch1_MSB = NofMotions / 0x100;
	mov A,[X+2]
	mov [_Report+3],A
	.dbline 250
; 
; 			
; 				NewSample = TRUE;
	mov REG[0xd0],>_NewSample
	mov [_NewSample],1
	.dbline 252
; 			
; 				FSM = eIdle;
	mov REG[0xd0],>_FSM
	mov [_FSM],1
	.dbline 253
; 				break;			
L17:
L18:
	.dbline -2
	.dbline 256
; 			}
; 	}
; }
L14:
	add SP,-4
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l NofMotions 2 i
	.dbend
	.dbfunc e Sensor_Debug _Sensor_Debug fV
_Sensor_Debug::
	.dbline -1
	.dbline 260
; 
; //-----------------------------------------------------------------------------
; void Sensor_Debug(void)
; {
	.dbline -2
	.dbline 262
; /* currently no debug function */
; }
L30:
	.dbline 0 ; func end
	ret
	.dbend
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM2_0::
	.byte 0
	.dbsym e DM2_0 _DM2_0 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM2_1::
	.byte 0
	.dbsym e DM2_1 _DM2_1 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM2_2::
	.byte 0
	.dbsym e DM2_2 _DM2_2 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM0_0::
	.byte 0
	.dbsym e DM0_0 _DM0_0 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM0_1::
	.byte 0
	.dbsym e DM0_1 _DM0_1 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM0_2::
	.byte 0
	.dbsym e DM0_2 _DM0_2 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_Countdown_1ms::
	.byte 0,0
	.dbsym e Countdown_1ms _Countdown_1ms i
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_FSM::
	.byte 0
	.dbsym e FSM _FSM c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_Report::
	.byte 0,0,0,0
	.dbsym e Report _Report X
